<template>
  <v-container>
    <v-row justify="space-between">
      <v-col cols="12" md="5">
        <p class="page-title">
          Configuración de las citas
        </p>
      </v-col>
    </v-row>
    <v-card class="mx-auto responsible-card" max-width="100%">
      <v-card-subtitle class="pb-0">
        <v-form ref="form" lazy-validation>
          <v-container fluid>
            <v-row>
              <v-col cols="4">
                <v-subheader>
                  Duración de citas&nbsp
                  <h3 class="primary--text">
                    *
                  </h3>
                  :
                </v-subheader>
              </v-col>
              <v-col cols="2">
                <v-text-field
                  v-model="configuration.appointmentDuration"
                  single-line
                  outlined
                  type="time"
                  :disabled="configDisable"
                  hide-details="auto"
                />
              </v-col>
            </v-row>
            <v-row>
              <v-col cols="4">
                <v-subheader>
                  Cantidad máxima de sesiones &nbsp
                  <h3 class="primary--text">
                    *
                  </h3>
                  :
                </v-subheader>
              </v-col>
              <v-col cols="2" style="display=flex">
                <v-text-field
                  v-model="configuration.appointmentMaxCant"
                  single-line
                  outlined
                  label="cantidad"
                  hide-details="auto"
                  type="number"
                  :disabled="configDisable"
                />
              </v-col>
              <v-col cols="3">
                <v-subheader>
                  (paciente x semana)
                </v-subheader>
              </v-col>
            </v-row>
            <v-row>
              <v-col cols="4">
                <v-subheader>
                  Cantidad máxima de cancelaciones &nbsp
                  <h3 class="primary--text">
                    *
                  </h3>
                  :
                </v-subheader>
              </v-col>
              <v-col cols="2" style="display=flex">
                <v-text-field
                  v-model="configuration.appointmentMaxCancelled"
                  single-line
                  outlined
                  label="cantidad"
                  hide-details="auto"
                  type="number"
                  :disabled="configDisable"
                />
              </v-col>
              <v-col cols="3">
                <v-subheader>
                  (paciente/especialista x semana)
                </v-subheader>
              </v-col>
            </v-row>
            <v-row>
              <v-col cols="4">
                <v-subheader>
                  Tiempo para cancelación &nbsp
                  <h3 class="primary--text">
                    *
                  </h3>
                  :
                </v-subheader>
              </v-col>
              <v-col cols="2" style="display=flex">
                <v-text-field
                  v-model="configuration.appointmentTimeToCancel"
                  single-line
                  outlined
                  type="time"
                  :disabled="configDisable"
                  hide-details="auto"
                />
              </v-col>
              <v-col cols="3">
                <v-subheader>
                  (tiempo previo a una cita)
                </v-subheader>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
      </v-card-subtitle>
      <v-card-actions class="d-flex justify-end">
        <v-btn
          v-show="!showButtons"
          depressed
          color="primary"
          style="padding: 15px"
          rounded
          outlined
          @click="editar"
        >
          EDITAR
        </v-btn>
        <v-btn
          v-show="showButtons"
          depressed
          color="primary"
          style="padding: 15px"
          :disabled="saveDisable"
          rounded
          @click="save"
        >
          GUARDAR
        </v-btn>
        <v-btn
          v-show="showButtons"
          depressed
          color="primary"
          style="padding: 15px"
          rounded
          outlined
          @click="showEditButtons"
        >
          CANCELAR
        </v-btn>
      </v-card-actions>
    </v-card>

    <br>
    <v-snackbar v-model="snackBar.show" :color="snackBar.color" text top>
      {{ snackBar.text }}
      <template #action="{ attrs }">
        <v-btn color="blue" text v-bind="attrs" @click="snackBar.show = false">
          <v-icon>mdi-window-close</v-icon>
        </v-btn>
      </template>
    </v-snackbar>
    <confirmation-modal :is-open="showModal" :modal-text="modalText" @confirm="confirmConfigUpdate" @cancel="cancelUpdate" />
  </v-container>
</template>
<script>
import { mapActions, mapState } from 'vuex';
import ConfirmationModal from '~/components/register/confirmationModal';

export default {
  name: 'Configuration',
  components: { ConfirmationModal },
  data() {
    return {
      showModal: false,
      modalText: '¿Estás seguro que deseas guardar los cambios?',
      configuration: {
        appointmentDuration: '',
        appointmentMaxCant: '',
        appointmentMaxCancelled: '',
        appointmentTimeToCancel: '',
      },
      oldConf: {
        appointmentDuration: '',
        appointmentMaxCant: '',
        appointmentMaxCancelled: '',
        appointmentTimeToCancel: '',
      },
      snackBar: {
        show: false,
        color: '',
        text: '',
      },
      showButtons: false,
      configDisable: true,
      saveDisable: true,
    };
  },
  computed: {
    ...mapState({
      configurationParams: state => state.providercompany.configuration.configurationParams,
      catchError: state => state.providercompany.configuration.catchError,
    //   supervisors: state => state['client-supervisor'].supervisors,
    }),
  },
  watch: {
    'configuration.appointmentDuration'(newVal, oldVal) {
      this.saveDisable = false;
    },
    'configuration.appointmentMaxCant'(newVal, oldVal) {
      this.saveDisable = false;
    },
    'configuration.appointmentMaxCancelled'(newVal, oldVal) {
      this.saveDisable = false;
    },
  },
  async mounted() {
    await this.getConfigurationParams({ id: this.$route.params.id });
    // assign values to the configuration object
    this.oldConf = this.configurationParams;
    this.configuration.appointmentDuration = this.convertHMS(this.configurationParams.appointmentDuration);
    this.configuration.appointmentMaxCant = this.configurationParams.appointmentMaxCant;
    this.configuration.appointmentMaxCancelled = this.configurationParams.appointmentMaxCancelled;
    this.configuration.appointmentTimeToCancel = this.convertHMS(this.configurationParams.appointmentTimeToCancel);
  },
  methods: {
    ...mapActions({
      updateConfigurationParams: 'providercompany/configuration/updateConfigurationParams',
      getConfigurationParams: 'providercompany/configuration/getConfigurationParams',
    }),
    editar() {
      this.showButtons = true;
      this.configDisable = false;
    },
    showEditButtons() {
      this.showButtons = !this.showButtons;
      this.configDisable = true;
      this.saveDisable = true;
      // reset configuration values
      this.configuration.appointmentDuration = this.convertHMS(this.oldConf.appointmentDuration);
      this.configuration.appointmentMaxCant = this.oldConf.appointmentMaxCant;
      this.configuration.appointmentMaxCancelled = this.oldConf.appointmentMaxCancelled;
      this.configuration.appointmentTimeToCancel = this.convertHMS(this.oldConf.appointmentTimeToCancel);
    },
    save() {
      if (this.configuration.appointmentMaxCant !== '' && this.configuration.appointmentMaxCancelled !== '' &&
        this.configuration.appointmentDuration !== '00:00' && this.configuration.appointmentTimeToCancel !== '00:00') {
        this.showModal = true;
      } else {
        this.snackBar.text = 'Ingrese valores válidos';
        this.snackBar.color = 'error';
        this.snackBar.show = true;
      }
    },
    changeToMin(time) {
      const a = time.split(':'); // split it at the colons
      // Hours are worth 60 minutes.
      const minutes = (+a[0]) * 60 + (+a[1]);
      return minutes;
    },
    async confirmConfigUpdate() {
      await this.configUpdate();
      this.configDisable = true;
    },
    async configUpdate() {
      const durationMin = this.changeToMin(this.configuration.appointmentDuration);
      const timeToCancel = this.changeToMin(this.configuration.appointmentTimeToCancel);
      const formData = new Object();
      formData.appointmentDuration = durationMin;
      formData.appointmentMaxCant = parseInt(this.configuration.appointmentMaxCant);
      formData.appointmentMaxCancelled = parseInt(this.configuration.appointmentMaxCancelled);
      formData.appointmentTimeToCancel = timeToCancel;
      formData.id = this.$route.params.id;
      await this.updateConfigurationParams(formData);
      if (this.catchError) {
        this.showButtons = false;
        this.snackBar.text = 'No se ha podido actualizar la información';
        this.snackBar.color = 'error';
        this.snackBar.show = true;
      } else {
        this.showButtons = false;
        this.snackBar.text = 'Información actualizada correctamente';
        this.snackBar.color = 'primary';
        this.snackBar.show = true;
      }
    },
    cancelUpdate() {
      this.showModal = false;
    },
    convertHMS(value) {
      value = value * 60;
      const sec = parseInt(value, 10); // convert value to number if it's string
      let hours = Math.floor(sec / 3600); // get hours
      let minutes = Math.floor((sec - (hours * 3600)) / 60); // get minutes
      let seconds = sec - (hours * 3600) - (minutes * 60); //  get seconds
      // add 0 if value < 10; Example: 2 => 02
      if (hours < 10) { hours = '0' + hours; }
      if (minutes < 10) { minutes = '0' + minutes; }
      if (seconds < 10) { seconds = '0' + seconds; }
      return hours + ':' + minutes + ':' + '00'; // Return is HH : MM : SS
    },
  },
};
</script>

<style scoped>
.page-title {
  font-family: 'Montserrat', sans-serif;
  font-size: 1.5rem;
  margin-top: 1rem;
  margin-left: 1rem;
}
.buttonRegisterLeft {
  margin-top: 1rem;
}
</style>
